package com.example.gengmei_flutter_plugin.utils

import android.content.Context
import android.util.Log
import com.example.myimagepicker.luban.Luban
import java.io.File
import android.media.ThumbnailUtils
import android.graphics.Bitmap
import android.util.DebugUtils
import java.io.FileOutputStream
import java.lang.Exception


/**
 * @author lsy
 * @date   2019-09-10
 */

class MyUtil {


    companion object {
        fun getImageCacheDir(context: Context, cacheName: String): File? {
            val cacheDir = context.externalCacheDir
            if (cacheDir != null) {
                val result = File(cacheDir, cacheName)
                return if (!result.mkdirs() && (!result.exists() || !result.isDirectory)) {
                    // File wasn't able to create a directory, or the result exists but not a directory
                    null
                } else result
            }
            if (Log.isLoggable(Luban.TAG, Log.ERROR)) {
                Log.e(Luban.TAG, "default disk cache dir is null")
            }
            return null
        }


        fun getFileName(pathandname: String): String? {
            val start = pathandname.lastIndexOf("/")
            val end = pathandname.lastIndexOf(".")
            return if (start != -1 && end != -1) {
                pathandname.substring(start + 1, end)
            } else {
                null
            }
        }

        fun getFileFullName(pathandname: String): String? {
            val start = pathandname.lastIndexOf("/")
            val end = pathandname.lastIndexOf(".")
            return if (start != -1 && end != -1) {
                pathandname.substring(start + 1, pathandname.length)
            } else {
                null
            }
        }

        fun saveVideoImg(filePath: String, videoPath: String, kind: Int, width: Int, height: Int): String {
            val file = File(filePath);
            var bitmap: Bitmap? = null
            // 获取视频的缩略图
            bitmap = ThumbnailUtils.createVideoThumbnail(videoPath, kind)
            if (width > 0 && height > 0) {
                bitmap = ThumbnailUtils.extractThumbnail(bitmap, width, height,
                        ThumbnailUtils.OPTIONS_RECYCLE_INPUT)
            }
            try {
                val out = FileOutputStream(file)
                bitmap.compress(Bitmap.CompressFormat.PNG, 80, out)
                out.flush()
                out.close()
                bitmap.recycle()
            } catch (e: Exception) {
                e.printStackTrace()
            }
            return filePath
        }


    }
}
